﻿--[[
	CHT (Chattool ... simple but it works ;) )
	
	This tool was designed for raidgroups spread over at least 2 guilds.
	It allows you to use a new channel for easier communication between those guilds.
	The channel is fixed like the guild and the raid channel.
	CHT also idintifies you to other members of the channel with your known character(name) even if you
	are online with a twink.
	
	issues:
		- after disabling a FrameChatWindow error occures (fixed)
						
	changes:
		- 3.0.0 WotLK  reintroduction/returned
		- 1.0.7 CHT join/leave Event implementation changed
		- 1.0.6 GemChat ChannelJoinEvent fixed
		- 1.0.4 SecureHookError fixed
		- 1.0.3 join/leave-channel event NEW, change of custom channel possible during gameplay
				GemChat plugin implemented
		- 1.0.2 tank and dd channel introduced
		- 1.0.1 healer channel introduced, minor bugfixes
		- 1.0.0 first release version: Class Raidchannel, standard Global Channel, guild officer chat sticky too ;)
				not compatible with versions pre 1.0.0
]]

CHT = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0","AceComm-2.0","AceDB-2.0","AceHook-2.1");

--dropdown menu
--local dewdrop = AceLibrary("Dewdrop-2.0");

--local variables
local prefixcht = "CHT";		-- AceComm needed ID prefix
local chtchannel = prefixcht;	-- standard channel
local version = "v".."2";		-- versionnumber to assure message transfer only between compatible CHT versions

--Colors
local CHT_RED = "|cffff0000";
local CHT_GREEN = "|cff00ff00";
local CHT_BLUE = "|cff0000ff";
local CHT_YELLOW = "|cffffff00";
local CHT_WHITE = "|cffffffff";
local CHT_BLACK = "|cff000000";

------------------------------
--message package definition--
------------------------------
--[[
local pkg = {
	cmd = <string>, 		-- chat, (ask,answer, [who, council]), event
	channel = <string>,		-- name of the subchannel.
	tag = <string>,			-- "Main","",nil,"undef" or the name of the main character(self.db.realm.mainname). - only with cmd = "chat"
	guild = <string>, 		-- "",nil,"undef or the guild name of the main characters guild(self.db.realm.mainguild). - only with cmd = "chat"
	class = <string>,		-- your class
	msg = <string>,			-- text message
	cmdval = <int>,			-- command value. - only with cmd = "ask" && "answer"
	recipient = <string>	-- player who called "ask" command. - only with "answer"
]]
CHT._Q = {
	["who"] = 1,
	["council"] = 2,
};
---------------------------------------
--Kind (Damage Dealer, Healer, Tank) --
---------------------------------------
CHT._K = {
	["dd"] = "dd",
	["healer"] = "healer",
	["tank"] = "tank"
};
----------
--Events--
----------
CHT._E = {
	["chtjoin"] = 1,
	["chtleave"] = 2,
};

-----------------
--Raid specific--
-----------------
CHT.isRaid = false;

-----------------
--cht chattable--
-----------------
CHT.chatter = { };

------------------
--standard block--
------------------
--initialization
function CHT:OnInitialize()

	self:RegisterDB("CHTDB","CHTPCDB");
	
	self:RegisterDefaults('char',{
		autojoin = true,
		kind = nil
	});
	self:RegisterDefaults('realm',{
		mainname = "",
		mainguild = "",
		channel = chtchannel,
		guilds = { }
	});
		
	self:RegisterDefaults('profile',{
		chatframe = 1,
		showguild = true,
		showtag = true,
		raidchannels = {
			druid = {
				name = "Druids",
				type = 'toggle',
				desc = "Listen and write to the druid raidchannel.",
				get = function()
					return self.db.profile.subchannels.druid.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.druid.reg = (not self.db.profile.subchannels.druid.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			deathknight = {
				name = "Deathknights",
				type = 'toggle',
				desc = "Listen and write to the druid raidchannel.",
				get = function()
					return self.db.profile.subchannels.deathknight.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.deathknight.reg = (not self.db.profile.subchannels.deathknight.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			hunter = {
				name = "Hunters",
				type = 'toggle',
				desc = "Listen and write to the hunter raidchannel.",
				get = function()
					return self.db.profile.subchannels.hunter.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.hunter.reg = (not self.db.profile.subchannels.hunter.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			mage = {
				name = "Mages",
				type = 'toggle',
				desc = "Listen and write to the mage raidchannel.",
				get = function()
					return self.db.profile.subchannels.mage.reg;
				end,
				set = function()
					if(self:InRaid()==true)then
						self.db.profile.subchannels.mage.reg = (not self.db.profile.subchannels.mage.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			paladin = {
				name = "Paladins",
				type = 'toggle',
				desc = "Listen and write to the paladin raidchannel.",
				get = function()
					return self.db.profile.subchannels.paladin.reg;
				end,
				set = function()
					if(self:InRaid()==true)then
						self.db.profile.subchannels.paladin.reg = (not self.db.profile.subchannels.paladin.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			priest = {
				name = "Priests",
				type = 'toggle',
				desc = "Listen and write to the priest raidchannel.",
				get = function()
					return self.db.profile.subchannels.priest.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.priest.reg = (not self.db.profile.subchannels.priest.reg);	
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			rogue = {
				name = "Rogues",
				type = 'toggle',
				desc = "Listen and write to the rogue raidchannel.",
				get = function()
					return self.db.profile.subchannels.rogue.reg;
				end,
				set = function()
					if(self:InRaid() == true) then
						self.db.profile.subchannels.rogue.reg = (not self.db.profile.subchannels.rogue.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			shaman = {
				name = "Shamans",
				type = 'toggle',
				desc = "Listen and write to the shaman raidchannel.",
				get = function()
					return self.db.profile.subchannels.shaman.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.shaman.reg = (not self.db.profile.subchannels.shaman.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			warlock = {
				name = "Warlocks",
				type = 'toggle',
				desc = "Listen and write to the warlock  raidchannel.",
				get = function()
					return self.db.profile.subchannels.warlock .reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.warlock .reg = (not self.db.profile.subchannels.warlock .reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			warrior = {
				name = "Warriors",
				type = 'toggle',
				desc = "Listen and write to the warrior raidchannel.",
				get = function()
					return self.db.profile.subchannels.warrior.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.warrior.reg = (not self.db.profile.subchannels.warrior.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			healer = {
				name = "Healer",
				type = 'toggle',
				desc = "Listen and write to the healer raidchannel.",
				get = function()
					return self.db.profile.subchannels.healer.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.healer.reg = (not self.db.profile.subchannels.healer.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			dd = {
				name = "DamageDealer",
				type = 'toggle',
				desc = "Listen and write to the DD raidchannel.",
				get = function()
					return self.db.profile.subchannels.dd.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.dd.reg = (not self.db.profile.subchannels.dd.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
			tank = {
				name = "Tanks",
				type = 'toggle',
				desc = "Listen and write to the tank raidchannel.",
				get = function()
					return self.db.profile.subchannels.tank.reg;
				end,
				set = function()
					if(self:InRaid() == true)then
						self.db.profile.subchannels.tank.reg = (not self.db.profile.subchannels.tank.reg);
					end
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" }
			},
		},
		subchannels = {
			global = {
				--CHT specific for chat system
				def = "global",
				name = "Global",
				reg = true,
				cmd1 = "/chtglobal",
				cmd2 = "/ctg",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = 244/255,
				g = 108/255,
				b = 136/255,
				id = 51,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.global;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.global;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "GLOBAL"].r = r;
					ChatTypeInfo[prefixcht .. "GLOBAL"].g = g;
					ChatTypeInfo[prefixcht .. "GLOBAL"].b = b;
				end
			},
			--Raid Channels
			druid = {
				--CHT specific for chat system
				def = "druid",
				name = "Druids",
				reg = false,
				cmd1 = "/chtdruid",
				cmd2 = "/cdr",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["DRUID"].r,
				g = RAID_CLASS_COLORS["DRUID"].g,
				b = RAID_CLASS_COLORS["DRUID"].b,
				id = 52,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.druid;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.druid;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "DRUID"].r = r;
					ChatTypeInfo[prefixcht .. "DRUID"].g = g;
					ChatTypeInfo[prefixcht .. "DRUID"].b = b;
				end
			},
			deathknight = {
				--CHT specific for chat system
				def = "deathknight",
				name = "Deathknights",
				reg = false,
				cmd1 = "/chtdeath",
				cmd2 = "/cdk",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["DEATHKNIGHT"].r,
				g = RAID_CLASS_COLORS["DEATHKNIGHT"].g,
				b = RAID_CLASS_COLORS["DEATHKNIGHT"].b,
				id = 52,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.deathknight;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.deathknight;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "DEATHKNIGHT"].r = r;
					ChatTypeInfo[prefixcht .. "DEATHKNIGHT"].g = g;
					ChatTypeInfo[prefixcht .. "DEATHKNIGHT"].b = b;
				end
			},
			hunter = {
				--CHT specific for chat system
				def = "hunter",
				name = "Hunters",
				reg = false,
				cmd1 = "/chthunter",
				cmd2 = "/chu",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["HUNTER"].r,
				g = RAID_CLASS_COLORS["HUNTER"].g,
				b = RAID_CLASS_COLORS["HUNTER"].b,
				id = 53,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.hunter;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.hunter;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "HUNTER"].r = r;
					ChatTypeInfo[prefixcht .. "HUNTER"].g = g;
					ChatTypeInfo[prefixcht .. "HUNTER"].b = b;
				end
			},
			mage = {
				--CHT specific for chat system
				def = "mage",
				name = "Mages",
				reg = false,
				cmd1 = "/chtmage",
				cmd2 = "/cma",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["MAGE"].r,
				g = RAID_CLASS_COLORS["MAGE"].g,
				b = RAID_CLASS_COLORS["MAGE"].b,
				id = 54,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.mage;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.mage;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "MAGE"].r = r;
					ChatTypeInfo[prefixcht .. "MAGE"].g = g;
					ChatTypeInfo[prefixcht .. "MAGE"].b = b;
				end
			},
			paladin = {
				--CHT specific for chat system
				def = "paladin",
				name = "Paladins",
				reg = false,
				cmd1 = "/chtpaladin",
				cmd2 = "/cpa",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["PALADIN"].r,
				g = RAID_CLASS_COLORS["PALADIN"].g,
				b = RAID_CLASS_COLORS["PALADIN"].b,
				id = 55,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.paladin;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.paladin;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "PALADIN"].r = r;
					ChatTypeInfo[prefixcht .. "PALADIN"].g = g;
					ChatTypeInfo[prefixcht .. "PALADIN"].b = b;
				end
			},
			priest = {
				--CHT specific for chat system
				def = "priest",
				name = "Priests",
				reg = false,
				cmd1 = "/chtpriest",
				cmd2 = "/cpr",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["PRIEST"].r,
				g = RAID_CLASS_COLORS["PRIEST"].g,
				b = RAID_CLASS_COLORS["PRIEST"].b,
				id = 56,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.priest;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.priest;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "PRIEST"].r = r;
					ChatTypeInfo[prefixcht .. "PRIEST"].g = g;
					ChatTypeInfo[prefixcht .. "PRIEST"].b = b;
				end
			},
			rogue = {
				--CHT specific for chat system
				def = "rogue",
				name = "Rogues",
				reg = false,
				cmd1 = "/chtrogue",
				cmd2 = "/cro",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["ROGUE"].r,
				g = RAID_CLASS_COLORS["ROGUE"].g,
				b = RAID_CLASS_COLORS["ROGUE"].b,
				id = 57,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.rogue;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.rogue;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "ROGUE"].r = r;
					ChatTypeInfo[prefixcht .. "ROGUE"].g = g;
					ChatTypeInfo[prefixcht .. "ROGUE"].b = b;
				end
			},
			shaman = {
				--CHT specific for chat system
				def = "shaman",
				name = "Shamans",
				reg = false,
				cmd1 = "/chtshaman",
				cmd2 = "/csh",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["SHAMAN"].r,
				g = RAID_CLASS_COLORS["SHAMAN"].g,
				b = RAID_CLASS_COLORS["SHAMAN"].b,
				id = 58,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.shaman;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.shaman;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "SHAMAN"].r = r;
					ChatTypeInfo[prefixcht .. "SHAMAN"].g = g;
					ChatTypeInfo[prefixcht .. "SHAMAN"].b = b;
				end
			},
			warlock = {
				--CHT specific for chat system
				def = "warlock",
				name = "Warlocks",
				reg = false,
				cmd1 = "/chtwarlock",
				cmd2 = "/cwl",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["WARLOCK"].r,
				g = RAID_CLASS_COLORS["WARLOCK"].g,
				b = RAID_CLASS_COLORS["WARLOCK"].b,
				id = 59,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.warlock;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.warlock;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "WARLOCK"].r = r;
					ChatTypeInfo[prefixcht .. "WARLOCK"].g = g;
					ChatTypeInfo[prefixcht .. "WARLOCK"].b = b;
				end
			},
			warrior = {
				--CHT specific for chat system
				def = "warrior",
				name = "Warriors",
				reg = false,
				cmd1 = "/chtwarrior",
				cmd2 = "/cwa",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = RAID_CLASS_COLORS["WARRIOR"].r,
				g = RAID_CLASS_COLORS["WARRIOR"].g,
				b = RAID_CLASS_COLORS["WARRIOR"].b,
				id = 60,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.warrior;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.warrior;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "WARRIOR"].r = r;
					ChatTypeInfo[prefixcht .. "WARRIOR"].g = g;
					ChatTypeInfo[prefixcht .. "WARRIOR"].b = b;
				end
			},
			healer = {
				--CHT specific for chat system
				def = "healer",
				name = "Healer",
				reg = false,
				cmd1 = "/chthealer",
				cmd2 = "/che",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = 1,
				g = 1,
				b = 1,
				id = 61,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.healer;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.healer;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "HEALER"].r = r;
					ChatTypeInfo[prefixcht .. "HEALER"].g = g;
					ChatTypeInfo[prefixcht .. "HEALER"].b = b;
				end
			},
			dd = {
				--CHT specific for chat system
				def = "dd",
				name = "DD",
				reg = false,
				cmd1 = "/chtdd",
				cmd2 = "/cdd",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = 1,
				g = 1,
				b = 1,
				id = 62,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.dd;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.dd;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "DD"].r = r;
					ChatTypeInfo[prefixcht .. "DD"].g = g;
					ChatTypeInfo[prefixcht .. "DD"].b = b;
				end
			},
			tank = {
				--CHT specific for chat system
				def = "tank",
				name = "Tank",
				reg = false,
				cmd1 = "/chttank",
				cmd2 = "/cta",
				send = "both", 
				--Blizzard ChatSystem Variables
				sticky = 1,
				r = 1,
				g = 1,
				b = 1,
				id = 63,
				--Ace2 OptionSystem Variables
				type = 'color',
				desc = "Change channel color",
				get = function()
					local info = self.db.profile.subchannels.tank;
					return info.r, info.g, info.b
				end,
				set = function(r, g, b )
					local info = self.db.profile.subchannels.tank;
					info.r = r;
					info.g = g;
					info.b = b;
					ChatTypeInfo[prefixcht .. "TANK"].r = r;
					ChatTypeInfo[prefixcht .. "TANK"].g = g;
					ChatTypeInfo[prefixcht .. "TANK"].b = b;
				end
			}
		}
	});
	
	local chtmenu = {
		type = 'group',
		args = {
			settag = {
				name = "SetTag",
				type = 'text',
				desc = "Sets the tag shown befor your name",
				usage = "<tag>",
				get = function()
					return self.db.realm.mainname;
				end,
				set = function(tag)
					if( tag==nil or tag == "") then
						tag = UnitName("player");
					end
					self.db.realm.mainname = tag;
					self:Print("Tag set to " .. CHT_GREEN .. tag .."|r");
				end,
				validate = function(tag)
					return tag;
				end,
--[[				func = function()
					if(self.db.realm.mainname == "" or self.db.realm.mainname == nil or self.db.realm.mainname == "undef") then
						self.db.realm.mainname = UnitName("player");
						self.db.realm.mainguild,_,_ = GetGuildInfo("player");
						self:Print("Main set to " .. CHT_GREEN .. UnitName("player") .."|r");
					else
						self:Print("Cannot set this char as new main, demote your main first!");
					end
				end,]]
				order = 1
			},
			setguild = {
				name = "SetGuild",
				type = 'execute',
				desc = "Sets the Guildtag to your current Chars Guild.",
				func = function()
					self.db.realm.mainguild,_,_ = GetGuildInfo("player");
					self:Print("Guild set to " .. CHT_GREEN .. self.db.realm.mainguild .."|r");
				end,
				order = 2
			},
--[[			unsetmain = {
				name = "UnsetMain",
				type = 'execute',
				desc = "Demotes the MainChar",
				func = function()
					if(string.upper(self.db.realm.mainname) == string.upper(UnitName("player")) ) then
						self.db.realm.mainname = "";
						self.db.realm.mainguild = "";
						self:Print("Main ".. CHT_RED .."demoted|r");
					else
						self:Print("Cannot demote your main with this char. Your main can only demoted by your main!");
					end
				end,
				order = 2
			},]]
			setchannel = {
				name = "SetChannel",
				type = 'text',
				desc = "Sets the CHT Custom Channel",
				usage = "<channel>",
				get = function()
					return self.db.realm.channel;
				end,
				set = function(channel)
					self.db.realm.channel = channel;
					chtchannel = channel;
					self:ReregisterComm(); -- channel name change bugfix					
				end,
				validate = function(channel)
					return channel;
				end,
				order = 3
			},
			setkind = {
				name = "SetKind",
				type = 'text',
				desc = "Sets your Raidkind. (DD, Healer, Tank)",
				usage = "<kind>",
				get = function()
					return CHT._K[self.db.char.kind];
				end,
				set = function(kind)
					self.db.char.kind = string.lower(kind);
				end,
				valitade = function(kind)
					if( CHT._K[kind] == nil ) then
						return false;
					else
						return kind;
					end
				end,
				order = 4
			},
			autojoin = {
				name = "AutoJoin",
				type = 'toggle',
				desc = "Toggles autojoin for CHT on or off.",
				get = function()
					return self.db.char.autojoin;
				end,
				set = function()
					self.db.char.autojoin = (not self.db.char.autojoin);
					self:AutojoinFired(self.db.char.autojoin);
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" },
				order = 5
			},
			channelcolors = {
				name = "ChannelColors",
				type = 'group',
				desc = "Changing colors for subchannels",
				args = self.db.profile.subchannels,
				order = 6
			},
			chatframe = {
				name = "ChatFrame",
				type = 'text',
				desc = "Sets the ChatFrame for the CHT messages",
				usage = "<num>",
				get = function()
					return self.db.profile.chatframe;
				end,
				set = function(num)
					self.db.profile.chatframe = num;
				end,
				validate = function(num)
					if(tonumber(num) ~= nil)then
						if(tonumber(num) > 0)then
							return num;
						else
							return false;
						end
					end
				end,
				order = 7
			},
			who = {
				name = "Who",
				type = 'execute',
				desc = "Who is in the channel?",
				func = function()
					self:SendCmd(self.db.profile.subchannels.global.def, "ask", self._Q.who, "",UnitName("player") );
				end,
				order = 8
			},
			
			guilds = {
				name = "Guilds",
				type = 'group',
				desc = "Guilds in CHT",
				args = {
					list = {
						name = "List",
						type = 'execute',
						desc = "Lists all guilds which have been active in CHT",
						func = function()
							for k,g in pairs(self.db.realm.guilds) do
								self:DisplaySysMsg(g.short.." = "..g.name);
							end
						end
					}
				},
				order = 9
			},
			showguild = {
				name = "Showguild",
				type = 'toggle',
				desc = "Shows the guild of your main if defined.",
				get = function()
					return self.db.profile.showguild;
				end,
				set = function()
					self.db.profile.showguild = (not self.db.profile.showguild);
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" },
				order = 10
			},
			showtag = {
				name = "Showtag",
				type = 'toggle',
				desc = "Shows the defined tag. [Main] or [mainname]",
				get = function()
					return self.db.profile.showtag;
				end,
				set = function()
					self.db.profile.showtag = (not self.db.profile.showtag);
				end,
				map = { [false] = "|cffff0000".."Off".."|r", [true] = "|cff00ff00".."On".."|r" },
				order = 11
			},
			raidchannels = {
				name = "RaidChannels",
				type = 'group',
				desc = "En/disable class specific raid channels.",
				args = self.db.profile.raidchannels,
				order = 12
			},
			resetdb = {
				name = "ResetDB",
				type = 'execute',
				desc = "Resets the whole DB to default state.",
				func = function()
					self:ResetDB();
					self:Print("DB was reseted");
					self:ReregisterComm();
				end,
				order = 13
			},
		}
	}
	
	self:RegisterChatCommand( {"/cht"} , chtmenu);
	
	--[[local chtdd = {
		name = "CHT",
		type = 'execute',
		desc = "Call DropDown Menu",
		func = function()
			dewdrop:Open(Minimap);
		end,
	}
	]]

	self:RegisterChatCommand( {"/chtmenu"} , chtdd);
	
	--[[dewdrop:Register(Minimap,'children',
		function()
			dewdrop:FeedAceOptionsTable(chtmenu);
		end,
		'cursorX', true, 'cursorY', true);
	]]

	ChatTypeInfo["OFFICER"].sticky = 1;
	
	chtchannel = self.db.realm.channel;
	self:SetCommPrefix("CHT"..version);
	self.isRaid = false;

end

--enable
function CHT:OnEnable()
	self:AutojoinFired(self.db.char.autojoin);
	
	self:RegisterBucketEvent("RAID_ROSTER_UPDATE", 0.1, "UpdateRoster");
	self:RegisterEvent("CHAT_MSG_CHANNEL_JOIN", "ChannelJoin");	 --since 1.0.3
	self:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE", "ChannelLeave"); --since 1.0.3
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE", "ChannelActivity"); --since 1.0.6
	
	self:Hook("SendChatMessage",true);
			
	for k,c in pairs(self.db.profile.subchannels) do
		self:RegChannelWithCmd(c.def, c.cmd1, c.cmd2);
	end
	
	self:Print("CHT "..CHT_GREEN.."enabled|r. /cg for chat, /cht for menu.");
	
	self:UpdateRoster();
end

--disable
function CHT:OnDisable()
	if(self.db.char.autojoin == false)then
		self:SendEvent(self._E.chtleave);
	end

	for k,v in pairs(self.db.profile.subchannels) do
		self:UnregChannel(v.def);
	end

	self:Print("CHT "..CHT_RED.."disabled|r");
end

--done on autojoin toggled
function CHT:AutojoinFired(autojoin)
	if(autojoin == true)then
		self:RegisterComm(self.commPrefix,"CUSTOM",chtchannel,"ReceiveCustom");
		self:RegisterComm(self.commPrefix,"WHISPER","ReceiveWhisper");
	elseif(autojoin == false)then
		self:SendEvent(self._E.chtleave);
		self:UnregisterAllComms();
	end
end

--reregisters the CHT channel
function CHT:ReregisterComm()
	self:UnregisterAllComms();
	self:AutojoinFired(self.db.char.autojoin);
end
--

---------------
--event block--
---------------
--someone joined the channel
function CHT:ChannelJoin( a1, name, a3, a4, a5, a, a7, chNum, chName)
	if(string.lower(chName) == string.lower("AceComm" .. chtchannel)) then
		self.chatter[name] = true;
		self:PlayerJoined(name);
	end
end
--someone left the channel
function CHT:ChannelLeave( a1, name, a3, a4, a5, a6, a7, chNum, chName)
	if(string.lower(chName) == string.lower("AceComm" .. chtchannel)) then
		self:PlayerLeft(name);
	end
end

--channel selfjoin/leave (event)
function CHT:ChannelActivity( activityType, a2, a3, fullChannelName, a5, a6, a7, chNum, chName)
	if(activityType == "YOU_JOINED")then
		if(string.upper(chName) == string.upper("AceComm" .. self.db.realm.channel))then
			self:UnregisterEvent("CHAT_MSG_CHANNEL_NOTICE");
			--send join event
			if(self.db.char.autojoin)then
				self:SendEvent(self._E.chtjoin);
			end
		end
	end
end

--other player joines CHT
function CHT:PlayerJoined(player)
	self:DisplaySysMsg(player .. " joined CHT");
end
--other player leaves CHT
function CHT:PlayerLeft(player)
	self:DisplaySysMsg(player .. " left CHT");
end

--updates the raidroster
function CHT:UpdateRoster()
	local num = GetNumRaidMembers();

	if num == 0 then
		if self.isRaid then
			self:LeftRaid();
		end
		return
	end

	if not self.isRaid then
		self:JoinedRaid();
	end
end

--in a raid?
function CHT:InRaid()
	if(self.isRaid == true)then
		return true;
	else
		self:Print("Not in a Raid. Activation not possible.");
		return false;
	end	
end


-- joined raid
function CHT:JoinedRaid()
	local _,class = UnitClass("player");
	self.isRaid = true;
	
	self:RegisterComm(self.commPrefix,"RAID","ReceiveWhisper");
	self.db.profile.subchannels[string.lower(class)].reg = true;
	self:Print("New channel: "..class..", "..self.db.profile.subchannels[string.lower(class)].cmd1.." "..self.db.profile.subchannels[string.lower(class)].cmd2);
	
	
	local kind = self.db.char.kind;
	self.db.profile.subchannels[string.lower(kind)].reg = true;
	self:Print("You are marked as " ..kind.. ".");
	self:Print("New channel: "..kind..", "..self.db.profile.subchannels[string.lower(kind)].cmd1.." "..self.db.profile.subchannels[string.lower(kind)].cmd2);
end

-- left raid
function CHT:LeftRaid()
	local channels = self.db.profile.subchannels;
	
	if( self:IsCommRegistered(self.commPrefix, "RAID") ) then
		self:UnregisterComm(self.commPrefix,"RAID");
	end
	
	--class channels
	channels.druid.reg = false;
	channels.hunter.reg = false;
	channels.mage.reg = false;
	channels.paladin.reg = false;
	channels.priest.reg = false;
	channels.rogue.reg = false;
	channels.shaman.reg = false;
	channels.warlock.reg = false;
	channels.warrior.reg = false;
	
	--group channels (set all false in case of inconsistence)
	channels.dd.reg = false;
	channels.healer.reg = false;
	channels.tank.reg = false;
	
end
--

--------------------
--custom reg block--
--------------------
--register chatcmds for a channel
function CHT:RegChannelWithCmd(subchannel, cmd1, cmd2)
	local channel = string.upper(prefixcht .. subchannel);
	local info = self.db.profile.subchannels[subchannel];
	
	setglobal("SLASH_" .. channel .. "1", cmd1);
	setglobal("SLASH_" .. channel .. "2", cmd2);
	setglobal("CHAT_MSG_" .. channel, subchannel);
	setglobal("CHAT_" .. channel .."_SEND", info.name..": ");
	
	ChatTypeGroup[channel] = {
		"CHAT_MSG_" .. channel
	};
	
	ChatTypeInfo[channel] = {
		sticky = info.sticky,
		r = info.r,
		g = info.g,
		b = info.b,
		id = info.id,
		CHTNAME = subchannel
	};
	
	SlashCmdList[channel] = function(msg)
		self:SendMessage(subchannel,msg);
	end
end
--unregister chatcmds for a channel
function CHT:UnregChannel(subchannel)
	local channel = string.upper(prefixcht .. subchannel);
	
	setglobal("SLASH_" .. channel .. "1",nil);
	setglobal("SLASH_" .. channel .. "2",nil);
	setglobal("CHAT_MSG_" .. channel,nil);
	setglobal("CHAT_" .. channel .. "_SEND",nil);
	ChatTypeGroup[channel] = nil;
	ChatTypeInfo[channel] = nil;
	SlashCmdList[channel] = nil;
end
--

-----------------
--message block--
-----------------
--sends a message to other CHT members
function CHT:SendMessage(subchannel, text)
	text = self:TransformForSend(text);
	local _, realclass = UnitClass("player");
	local pkg = {
		cmd = "chat",
		channel = subchannel,
		guild = self.db.realm.mainguild,
		tag = self.db.realm.mainname,
		class = realclass,
		msg = text
	};
	
	if(pkg.tag == UnitName("player"))then
		pkg.tag = "Main";
	end
	
	if(self.db.profile.raidchannels[subchannel] == nil)then
		self:SendCommMessage("CUSTOM", chtchannel, pkg);
		self:SendCommMessage("WHISPER",UnitName("player"), pkg);
	elseif(self.db.profile.raidchannels[subchannel] ~= nil )then
		self:SendCommMessage("RAID", pkg);
		self:SendCommMessage("WHISPER",UnitName("player"), pkg);
	end
end
--sends a command to other CHT members of a spezial group
function CHT:SendCmd(subchannel, cmd, cmdval, text, recipient)
	local _, realclass = UnitClass("player");
	local pkg = {
		cmd = cmd,
		channel = subchannel,
		class = realclass,
		cmdval = cmdval,
		msg = text,
		recipient = recipient
	};
	
	self:SendCommMessage("CUSTOM",chtchannel, pkg);
	self:SendCommMessage("WHISPER",UnitName("player"), pkg);
end
--sends an event to other CHT members
function CHT:SendEvent(eventtype)
	local pkg = {
		cmd = "event",
		channel = "global",
		cmdval = eventtype
	};
	self:SendCommMessage("CUSTOM",chtchannel,pkg);
end

--sluice for custom channel recipient
function CHT:ReceiveCustom(prefix, sender, distribution, channelname, pkg)
	self:Receive(sender,pkg);
end
--sluice for whisper recipient
function CHT:ReceiveWhisper(prefix, sender, distribution, pkg)
	self:Receive(sender,pkg);
end

--real work for recipient
function CHT:Receive(sender,pkg)
	if(self.db.profile.subchannels[pkg.channel].reg == true)then
		if( string.upper(pkg.cmd) == string.upper("chat") )then
			if( self.chatter[sender] == nil or self.chatter[sender] == "" or self.chatter[sender] == false ) then 
				self.chatter[sender] = true;
			end
			self:ReadyForDisplay(sender,pkg);
		elseif(string.upper(pkg.cmd) == string.upper("ask"))then
			if(pkg.cmdval == self._Q.who)then
				self:SendCmd(pkg.channel, "answer", self._Q.who, self.db.realm.mainname, pkg.recipient);
			end
		elseif( (string.upper(pkg.cmd) == string.upper("answer")) and (string.upper(UnitName("player")) == string.upper(pkg.recipient)) )then
			if(pkg.cmdval == self._Q.who)then
				local cc = RAID_CLASS_COLORS[pkg.class];
				local color = "|cff".. self:numtohex(cc.r)..self:numtohex(cc.g)..self:numtohex(cc.b);
				local whotext = pkg.msg .. " = [|Hplayer:"..sender.."|h"..color..sender.."|r".."|h".."]";
				self:DisplaySysMsg(whotext);
			end
		elseif( string.upper(pkg.cmd) == string.upper("event")) then
			if(pkg.cmdval == self._E.chtjoin)then
				self:PlayerJoined(sender);
			elseif(pkg.cmdval == self._E.chtleave)then
				self:PlayerLeft(sender);
			end
		end
	end
end

--prepares header and message for a chatframe
function CHT:ReadyForDisplay(sender,pkg)
	local header = self:CreateHeader(pkg.channel, pkg.guild, pkg.tag, pkg.class, sender);
	pkg.msg = self:TransformForDisplay(pkg.msg);
	
	if( (strlen(header) + strlen(pkg.msg)) > 255)then
		self:DisplayMsg(pkg.channel, header);
		self:DisplayMsg(pkg.channel, pkg.msg);
	else
		self:DisplayMsg(pkg.channel, header .. pkg.msg);
	end
end

--retransforms a link for displaying
function CHT:TransformForDisplay(text)
	local newtext = string.gsub(text,"<{c}>","|c");
	newtext = string.gsub(newtext,"<{Hi}>","|Hitem");
	newtext = string.gsub(newtext,"<{Hp}>","|Hplayer");
	newtext = string.gsub(newtext,"<{h}>","|h");
	newtext = string.gsub(newtext,"<{r}>","|r");
	newtext = string.gsub(newtext,"<{ t }>"," %t ");
	return newtext;
end

--transforms a link to a transferable string
function CHT:TransformForSend(text)
	local newtext = string.gsub(text,"|c","<{c}>");
	newtext = string.gsub(newtext,"|Hitem","<{Hi}>");
	newtext = string.gsub(newtext,"|Hplayer","<{Hp}>");
	newtext = string.gsub(newtext,"|h","<{h}>");
	newtext = string.gsub(newtext,"|r","<{r}>");
	newtext = string.gsub(newtext," %t ","<{ t }>");
	return newtext;
end
--

-------------------
--display methods--
-------------------
--creates the channel header
function CHT:CreateHeader(channel,guild,tag,class,name)
	local header = "[" .. self.db.profile.subchannels[channel].name .."]";
	if(guild ~= "" and guild ~= nil and guild ~= "undef")then
		if( self.db.profile.showguild == true )then
			header = header .. " [" ..CHT_YELLOW .. self:guild_shorty_auto(guild) .."|r]";
		end
	end
	if(tag ~= "" and tag ~= nil and tag ~= "undef")then
		if(self.db.profile.showtag == true)then
			header = header .. " [" .. tag .."]";
		end
	end
	
	local color = {
		["r"] = 1,
		["g"] = 1,
		["b"] =1
	};
	if(class ~= nil and class ~= "undef") then
		color = RAID_CLASS_COLORS[class];
	else
		color.r = 219/255;
		color.g = 53/255;
		color.b = 86/255;
	end
	local classcolor = "|cff".. self:numtohex(color.r) .. self:numtohex(color.g) .. self:numtohex(color.b);
	header = header .. " [".."|Hplayer:".. name .."|h" .. classcolor .. name .. "|r".."|h".."]: ";
	
	return header;
end

--sends a message directly to a ChatFrame
function CHT:DisplayMsg(subchannel,msg)
	local channel = string.upper(prefixcht .. subchannel);
	local info = ChatTypeInfo[channel];
	local chatframe = getglobal("ChatFrame" .. self.db.profile.chatframe);
	chatframe:AddMessage(msg,info.r,info.g,info.b,info.id);
end

--display a SYSTEM message
function CHT:DisplaySysMsg(msg)
	local info = ChatTypeInfo["SYSTEM"];
	local chatframe = getglobal("ChatFrame" .. self.db.profile.chatframe);
	chatframe:AddMessage(msg,info.r,info.g,info.b,info.id);
end


--creates a guild shortcut (automatic)
function CHT:guild_shorty_auto(guildname)
	local guildshorty = "";
	local blank = {};
	local guild = string.gsub(guildname,"%s","");
	
	if( self.db.realm.guilds[string.upper(guild)] == nil )then
		for blank in string.gmatch(guildname,"%w+") do
			guildshorty = guildshorty .. string.sub(blank,1,1);
		end
	
		self.db.realm.guilds[string.upper(guild)] = {
			short = guildshorty,
			name = guildname
		}
	else
		guildshorty = self.db.realm.guilds[string.upper(guild)].short;
	end
	
	return guildshorty
end

--CHT adapted function for sending chat messages
function CHT:SendChatMessage(text, chattype, language, target)
	if( self.db.profile.subchannels[ChatTypeInfo[chattype].CHTNAME] ~= nil )then
		if( self.db.profile.subchannels[ChatTypeInfo[chattype].CHTNAME].reg == false) then
			self:Print("You are not registered for the channel: "..self.db.profile.subchannels[ChatTypeInfo[chattype].CHTNAME].name);
		else
			self:SendMessage(ChatTypeInfo[chattype].CHTNAME, text);
		end
	elseif( (chattype == "WHISPER") or (chattype == "CHANNEL") )then
		self.hooks.SendChatMessage(text, chattype, language, target);
	else
		self.hooks.SendChatMessage(text, chattype);
	end
end
--

-------------------
--Misc. functions--
-------------------
--workaround for hexadecimal values
function CHT:numtohex(number)
	return string.format("%02x",number * 255);
end
---------------
--END OF FILE--
---------------
